import ij.plugin.*;
import ij.plugin.filter.*;
import ij.gui.*;
import java.net.*;
import java.io.*;
///3B plugin cclass to bring up a basic help window.
///@ingroup gPlugin
public class CoxGroupCheckForUpdates implements PlugIn {

	public void run(final String arg)
	{
		String phone = ij.Prefs.get("cox_group.et_phone_home", "ask");
		System.out.println("phone home = " + phone);

		System.out.println("Running check: " + arg);

		if(phone.equals("ask"))
		{
			GenericDialog g = new GenericDialog("Automatically check for updates");
			g.addMessage(
				"This plugin can automatically check for updates.\n" +
				"\n"+
				"If you say yes, then the plugin will periodically check by\n" + 
				"fetching a file with a version number from https://coxphysics.com\n" + 
				"If you say no, then the plugin will never check, but you can \n" + 
				"always check manually yourself. ");


			g.setCancelLabel("No");
			g.setOKLabel("Yes");
			g.showDialog();
			
			if(g.wasCanceled())
			{
				System.out.println("No.");
				phone = "no";
			}
			else
			{
				System.out.println("Yes.");
				phone = "yes";
			}
			ij.Prefs.set("cox_group.et_phone_home", phone);
			ij.Prefs.savePreferences();
		}

		if(arg.equals("force") || (phone.equals("yes") && arg.equals("boot")&&!booted))
		{
			booted=true;
		
			String versionstr="";
			try{
				versionstr = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream("version.txt"))).readLine();
			}
			catch(IOException e)
			{
			}

			System.out.println("Current version string: " + versionstr);
			final long number = Long.valueOf(versionstr);
			System.out.println("Current version is: " + number);

			Runnable r = new Runnable(){
				public void run(){
					try{
						URL oracle = new URL("https://coxphysics.com/plugin_latest_version.txt");
						BufferedReader in = new BufferedReader(
						new InputStreamReader(oracle.openStream()));

						String inputLine;
						inputLine = in.readLine();
						System.out.println("++++++++++++ " + inputLine);
						in.close();

						long number2 = Long.valueOf(inputLine);

						System.out.println("Newest version is: " + number2);

						if(number2 > number)
						{
							System.out.println("New version");
							GenericDialog gd = new GenericDialog("New version!");
							gd.addMessage("A new version is available");
							gd.addMessage("Please visit https://coxphysics.com");
							gd.hideCancelButton();
							gd.showDialog();
						}
						else if(arg.equals("force"))
						{
							GenericDialog gd = new GenericDialog("No new version.");
							gd.addMessage("Your version of the Cox Group plugin is up to date.");
							gd.hideCancelButton();
							gd.showDialog();

						}

					}
					catch(MalformedURLException e)
					{
						System.out.println(e.getMessage());
					}
					catch(IOException e)
					{
						System.out.println(e.getMessage());
					}
				}
			};

			new Thread(r).start();
		}
	}

	static boolean booted=false;
};
